
/*  A Bison parser, made from gram.y  */

#define YYBISON 1  /* Identify Bison output.  */

#define	STRING	258
#define	NUMBER	259
#define	FNUMBER	260
#define	RANGE	261
#define	VAR	262
#define	WORD	263
#define	COL	264
#define	S_FORMAT	265
#define	S_FMT	266
#define	S_LABEL	267
#define	S_LEFTSTRING	268
#define	S_RIGHTSTRING	269
#define	S_GET	270
#define	S_PUT	271
#define	S_MERGE	272
#define	S_LET	273
#define	S_WRITE	274
#define	S_TBL	275
#define	S_COPY	276
#define	S_SHOW	277
#define	S_ERASE	278
#define	S_FILL	279
#define	S_LOCK	280
#define	S_UNLOCK	281
#define	S_GOTO	282
#define	S_DEFINE	283
#define	S_UNDEFINE	284
#define	S_VALUE	285
#define	S_MDIR	286
#define	S_HIDE	287
#define	S_SET	288
#define	K_ERROR	289
#define	K_INVALID	290
#define	K_FIXED	291
#define	K_SUM	292
#define	K_PROD	293
#define	K_AVG	294
#define	K_STDDEV	295
#define	K_COUNT	296
#define	K_ABS	297
#define	K_ACOS	298
#define	K_ASIN	299
#define	K_ATAN	300
#define	K_ATAN2	301
#define	K_CEIL	302
#define	K_COS	303
#define	K_EXP	304
#define	K_FABS	305
#define	K_FLOOR	306
#define	K_HYPOT	307
#define	K_LN	308
#define	K_LOG	309
#define	K_PI	310
#define	K_POW	311
#define	K_SIN	312
#define	K_SQRT	313
#define	K_TAN	314
#define	K_DTR	315
#define	K_RTD	316
#define	K_MAX	317
#define	K_MIN	318
#define	K_RND	319
#define	K_ROUND	320
#define	K_IF	321
#define	K_PV	322
#define	K_FV	323
#define	K_PMT	324
#define	K_HOUR	325
#define	K_MINUTE	326
#define	K_SECOND	327
#define	K_MONTH	328
#define	K_DAY	329
#define	K_YEAR	330
#define	K_NOW	331
#define	K_DATE	332
#define	K_DTS	333
#define	K_TTS	334
#define	K_FMT	335
#define	K_SUBSTR	336
#define	K_UPPER	337
#define	K_LOWER	338
#define	K_CAPITAL	339
#define	K_STON	340
#define	K_EQS	341
#define	K_EXT	342
#define	K_NVAL	343
#define	K_SVAL	344
#define	K_LOOKUP	345
#define	K_HLOOKUP	346
#define	K_VLOOKUP	347
#define	K_INDEX	348
#define	K_STINDEX	349
#define	K_AUTO	350
#define	K_AUTOCALC	351
#define	K_BYROWS	352
#define	K_BYCOLS	353
#define	K_ITERATIONS	354
#define	K_NUMERIC	355
#define	K_PRESCALE	356
#define	K_EXTFUN	357
#define	K_CELLCUR	358
#define	K_TOPROW	359
#define	K_TBLSTYLE	360
#define	K_TBL	361
#define	K_LATEX	362
#define	K_SLATEX	363
#define	K_TEX	364
#define	K_FRAME	365
#define	K_RNDINFINITY	366
#define	K_MYROW	367
#define	K_MYCOL	368
#define	K_COLTOA	369
#define	K_CRACTION	370
#define	K_CRROW	371
#define	K_CRCOL	372
#define	K_ROWLIMIT	373
#define	K_COLLIMIT	374
#define	K_NUMITER	375
#define	K_MATRIX_ADD	376
#define	K_MATRIX_SUB	377
#define	K_MATRIX_INV	378
#define	K_MATRIX_MULT	379
#define	K_MATRIX_TRANS	380
#define	K_GRAPH	381

#line 17 "gram.y"

#ifdef DOINGX
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#else
#include <curses.h>
#endif

#ifdef IEEE_MATH
# include <ieeefp.h>
#endif /* IEEE_MATH */

#include <math.h>
#include "sc.h"

#ifndef PI
#define PI (double)3.14159265358979323846
#endif

#define ENULL (struct enode *)0

#line 40 "gram.y"
typedef union {
    int ival;
    double fval;
    struct ent_ptr ent;
    struct enode *enode;
    char *sval;
    struct range_s rval;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		559
#define	YYFLAG		-32768
#define	YYNTBASE	149

#define YYTRANSLATE(x) ((unsigned)(x) <= 381 ? yytranslate[x] : 161)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   134,     2,   137,   148,   140,   130,     2,   143,
   144,   138,   135,   145,   136,     2,   139,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   128,     2,   131,
   132,   133,   127,   142,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,   141,   146,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,   129,     2,   147,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
   126
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     5,    10,    15,    20,    28,    34,    41,    46,    49,
    52,    55,    59,    62,    66,    69,    73,    76,    81,    86,
    89,    92,    96,    98,   101,   103,   106,   110,   115,   119,
   121,   124,   126,   129,   132,   135,   138,   141,   143,   146,
   150,   154,   157,   160,   161,   163,   165,   168,   174,   180,
   186,   192,   198,   204,   212,   218,   226,   232,   238,   244,
   250,   258,   264,   270,   276,   282,   288,   296,   302,   308,
   316,   322,   328,   334,   340,   346,   352,   360,   370,   380,
   390,   400,   406,   412,   418,   424,   430,   436,   439,   449,
   459,   465,   473,   479,   487,   493,   499,   505,   513,   521,
   531,   541,   549,   557,   565,   573,   583,   587,   590,   593,
   595,   597,   603,   605,   608,   610,   613,   616,   619,   622,
   628,   631,   641,   651,   659,   669,   677,   681,   685,   689,
   693,   697,   701,   703,   709,   713,   717,   721,   725,   729,
   734,   739,   744,   749,   753,   755,   759,   763,   765,   768,
   772,   776,   781,   783,   785,   787,   789,   791,   794,   797,
   799,   801,   802,   805,   807,   809,   812,   815,   818,   821,
   823,   825,   827,   830,   832,   835,   837,   840,   842,   845,
   847,   850,   854,   858,   862,   866,   870,   874,   878,   880,
   883,   887,   891,   895,   897
};

#endif

static const short yyrhs[] = {    18,
   155,   132,   151,     0,    12,   155,   132,   151,     0,    13,
   155,   132,   151,     0,    14,   155,   132,   151,     0,    10,
     9,   128,     9,     4,     4,     4,     0,    10,     9,     4,
     4,     4,     0,    10,     9,   128,     9,     4,     4,     0,
    10,     9,     4,     4,     0,    15,   157,     0,    17,   157,
     0,    31,   157,     0,    16,   157,   153,     0,    16,   157,
     0,    19,   157,   153,     0,    19,   157,     0,    20,   157,
   153,     0,    20,   157,     0,    22,     9,   128,     9,     0,
    22,     4,   128,     4,     0,    32,     9,     0,    32,     4,
     0,    21,   153,   155,     0,    23,     0,    23,   155,     0,
    30,     0,    30,   155,     0,    24,   156,   156,     0,    24,
   155,   156,   156,     0,    11,   155,     3,     0,    25,     0,
    25,   155,     0,    26,     0,    26,   155,     0,    27,   155,
     0,    27,   156,     0,    27,   160,     0,    27,     3,     0,
    27,     0,    28,   157,     0,    28,   157,   153,     0,    28,
   157,   154,     0,    29,   155,     0,    33,   158,     0,     0,
     1,     0,   154,     0,    36,   150,     0,   142,    37,   143,
   155,   144,     0,   142,    38,   143,   155,   144,     0,   142,
    39,   143,   155,   144,     0,   142,    40,   143,   155,   144,
     0,   142,    41,   143,   155,   144,     0,   142,    62,   143,
   155,   144,     0,   142,    62,   143,   151,   145,   152,   144,
     0,   142,    63,   143,   155,   144,     0,   142,    63,   143,
   151,   145,   152,   144,     0,   142,    42,   143,   151,   144,
     0,   142,    43,   143,   151,   144,     0,   142,    44,   143,
   151,   144,     0,   142,    45,   143,   151,   144,     0,   142,
    46,   143,   151,   145,   151,   144,     0,   142,    47,   143,
   151,   144,     0,   142,    48,   143,   151,   144,     0,   142,
    49,   143,   151,   144,     0,   142,    50,   143,   151,   144,
     0,   142,    51,   143,   151,   144,     0,   142,    52,   143,
   151,   145,   151,   144,     0,   142,    53,   143,   151,   144,
     0,   142,    54,   143,   151,   144,     0,   142,    56,   143,
   151,   145,   151,   144,     0,   142,    57,   143,   151,   144,
     0,   142,    58,   143,   151,   144,     0,   142,    59,   143,
   151,   144,     0,   142,    60,   143,   151,   144,     0,   142,
    61,   143,   151,   144,     0,   142,    64,   143,   151,   144,
     0,   142,    65,   143,   151,   145,   151,   144,     0,   142,
    66,   143,   151,   145,   151,   145,   151,   144,     0,   142,
    67,   143,   151,   145,   151,   145,   151,   144,     0,   142,
    68,   143,   151,   145,   151,   145,   151,   144,     0,   142,
    69,   143,   151,   145,   151,   145,   151,   144,     0,   142,
    70,   143,   151,   144,     0,   142,    71,   143,   151,   144,
     0,   142,    72,   143,   151,   144,     0,   142,    73,   143,
   151,   144,     0,   142,    74,   143,   151,   144,     0,   142,
    75,   143,   151,   144,     0,   142,    76,     0,   142,    78,
   143,   151,   145,   151,   145,   151,   144,     0,   142,    79,
   143,   151,   145,   151,   145,   151,   144,     0,   142,    85,
   143,   151,   144,     0,   142,    86,   143,   151,   145,   151,
   144,     0,   142,    77,   143,   151,   144,     0,   142,    80,
   143,   151,   145,   151,   144,     0,   142,    82,   143,   151,
   144,     0,   142,    83,   143,   151,   144,     0,   142,    84,
   143,   151,   144,     0,   142,    93,   143,   151,   145,   155,
   144,     0,   142,    90,   143,   151,   145,   155,   144,     0,
   142,    91,   143,   151,   145,   155,   145,   151,   144,     0,
   142,    92,   143,   151,   145,   155,   145,   151,   144,     0,
   142,    94,   143,   151,   145,   155,   144,     0,   142,    87,
   143,   151,   145,   151,   144,     0,   142,    88,   143,   151,
   145,   151,   144,     0,   142,    89,   143,   151,   145,   151,
   144,     0,   142,    81,   143,   151,   145,   151,   145,   151,
   144,     0,   143,   151,   144,     0,   135,   150,     0,   136,
   150,     0,     4,     0,     5,     0,     4,   146,     4,   146,
     4,     0,    55,     0,   142,    55,     0,     3,     0,   147,
   150,     0,   134,   150,     0,   142,   112,     0,   142,   113,
     0,   142,   114,   143,   151,   144,     0,   142,   120,     0,
   142,   121,   143,   155,   145,   155,   145,   155,   144,     0,
   142,   122,   143,   155,   145,   155,   145,   155,   144,     0,
   142,   123,   143,   155,   145,   155,   144,     0,   142,   124,
   143,   155,   145,   155,   145,   155,   144,     0,   142,   125,
   143,   155,   145,   155,   144,     0,   151,   135,   151,     0,
   151,   136,   151,     0,   151,   138,   151,     0,   151,   139,
   151,     0,   151,   140,   151,     0,   151,   141,   151,     0,
   150,     0,   151,   127,   151,   128,   151,     0,   151,   131,
   151,     0,   151,   132,   151,     0,   151,   133,   151,     0,
   151,   130,   151,     0,   151,   129,   151,     0,   151,   131,
   132,   151,     0,   151,   134,   132,   151,     0,   151,   131,
   133,   151,     0,   151,   133,   132,   151,     0,   151,   137,
   151,     0,   151,     0,   152,   145,   151,     0,   154,   128,
   154,     0,     6,     0,     9,     4,     0,   148,     9,     4,
     0,     9,   148,     4,     0,   148,     9,   148,     4,     0,
     7,     0,   153,     0,   154,     0,     4,     0,     5,     0,
   136,   156,     0,   135,   156,     0,     3,     0,   154,     0,
     0,   158,   159,     0,    95,     0,    96,     0,   147,    95,
     0,   147,    96,     0,   134,    95,     0,   134,    96,     0,
    98,     0,    97,     0,   100,     0,   134,   100,     0,   101,
     0,   134,   101,     0,   102,     0,   134,   102,     0,   103,
     0,   134,   103,     0,   104,     0,   134,   104,     0,    99,
   132,     4,     0,   105,   132,     4,     0,   105,   132,   106,
     0,   105,   132,   107,     0,   105,   132,   108,     0,   105,
   132,   109,     0,   105,   132,   110,     0,   111,     0,   134,
   111,     0,   115,   132,     4,     0,   118,   132,     4,     0,
   119,   132,     4,     0,    34,     0,    35,     0
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   193,   195,   197,   199,   201,   203,   205,   207,   209,   216,
   222,   224,   229,   232,   236,   238,   242,   244,   246,   248,
   250,   252,   255,   258,   260,   262,   266,   268,   270,   272,
   275,   277,   280,   282,   283,   284,   285,   286,   287,   297,
   298,   299,   300,   301,   302,   305,   306,   307,   309,   311,
   313,   315,   317,   319,   321,   323,   325,   326,   327,   328,
   329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
   339,   340,   341,   342,   343,   344,   345,   346,   348,   349,
   350,   352,   353,   354,   355,   356,   357,   358,   359,   361,
   363,   364,   365,   366,   367,   368,   369,   370,   372,   374,
   377,   380,   382,   383,   384,   385,   387,   388,   389,   390,
   391,   392,   407,   408,   409,   410,   411,   412,   413,   414,
   415,   418,   421,   424,   427,   430,   436,   437,   438,   439,
   440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
   450,   451,   452,   453,   457,   458,   461,   462,   465,   466,
   468,   470,   472,   475,   476,   480,   481,   482,   483,   487,
   488,   500,   501,   505,   506,   507,   508,   509,   510,   511,
   512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
   522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
   532,   533,   534,   538,   539
};

static const char * const yytname[] = {   "$","error","$illegal.","STRING","NUMBER",
"FNUMBER","RANGE","VAR","WORD","COL","S_FORMAT","S_FMT","S_LABEL","S_LEFTSTRING",
"S_RIGHTSTRING","S_GET","S_PUT","S_MERGE","S_LET","S_WRITE","S_TBL","S_COPY",
"S_SHOW","S_ERASE","S_FILL","S_LOCK","S_UNLOCK","S_GOTO","S_DEFINE","S_UNDEFINE",
"S_VALUE","S_MDIR","S_HIDE","S_SET","K_ERROR","K_INVALID","K_FIXED","K_SUM",
"K_PROD","K_AVG","K_STDDEV","K_COUNT","K_ABS","K_ACOS","K_ASIN","K_ATAN","K_ATAN2",
"K_CEIL","K_COS","K_EXP","K_FABS","K_FLOOR","K_HYPOT","K_LN","K_LOG","K_PI",
"K_POW","K_SIN","K_SQRT","K_TAN","K_DTR","K_RTD","K_MAX","K_MIN","K_RND","K_ROUND",
"K_IF","K_PV","K_FV","K_PMT","K_HOUR","K_MINUTE","K_SECOND","K_MONTH","K_DAY",
"K_YEAR","K_NOW","K_DATE","K_DTS","K_TTS","K_FMT","K_SUBSTR","K_UPPER","K_LOWER",
"K_CAPITAL","K_STON","K_EQS","K_EXT","K_NVAL","K_SVAL","K_LOOKUP","K_HLOOKUP",
"K_VLOOKUP","K_INDEX","K_STINDEX","K_AUTO","K_AUTOCALC","K_BYROWS","K_BYCOLS",
"K_ITERATIONS","K_NUMERIC","K_PRESCALE","K_EXTFUN","K_CELLCUR","K_TOPROW","K_TBLSTYLE",
"K_TBL","K_LATEX","K_SLATEX","K_TEX","K_FRAME","K_RNDINFINITY","K_MYROW","K_MYCOL",
"K_COLTOA","K_CRACTION","K_CRROW","K_CRCOL","K_ROWLIMIT","K_COLLIMIT","K_NUMITER",
"K_MATRIX_ADD","K_MATRIX_SUB","K_MATRIX_INV","K_MATRIX_MULT","K_MATRIX_TRANS",
"K_GRAPH","'?'","':'","'|'","'&'","'<'","'='","'>'","'!'","'+'","'-'","'#'",
"'*'","'/'","'%'","'^'","'@'","'('","')'","','","'_'","'~'","'$'","command",
"term","e","expr_list","range","var","var_or_range","num","strarg","setlist",
"setitem","errlist",""
};
#endif

static const short yyr1[] = {     0,
   149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
   149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
   149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
   149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
   149,   149,   149,   149,   149,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
   150,   150,   150,   150,   150,   150,   151,   151,   151,   151,
   151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
   151,   151,   151,   151,   152,   152,   153,   153,   154,   154,
   154,   154,   154,   155,   155,   156,   156,   156,   156,   157,
   157,   158,   158,   159,   159,   159,   159,   159,   159,   159,
   159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
   159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
   159,   159,   159,   160,   160
};

static const short yyr2[] = {     0,
     4,     4,     4,     4,     7,     5,     6,     4,     2,     2,
     2,     3,     2,     3,     2,     3,     2,     4,     4,     2,
     2,     3,     1,     2,     1,     2,     3,     4,     3,     1,
     2,     1,     2,     2,     2,     2,     2,     1,     2,     3,
     3,     2,     2,     0,     1,     1,     2,     5,     5,     5,
     5,     5,     5,     7,     5,     7,     5,     5,     5,     5,
     7,     5,     5,     5,     5,     5,     7,     5,     5,     7,
     5,     5,     5,     5,     5,     5,     7,     9,     9,     9,
     9,     5,     5,     5,     5,     5,     5,     2,     9,     9,
     5,     7,     5,     7,     5,     5,     5,     7,     7,     9,
     9,     7,     7,     7,     7,     9,     3,     2,     2,     1,
     1,     5,     1,     2,     1,     2,     2,     2,     2,     5,
     2,     9,     9,     7,     9,     7,     3,     3,     3,     3,
     3,     3,     1,     5,     3,     3,     3,     3,     3,     4,
     4,     4,     4,     3,     1,     3,     3,     1,     2,     3,
     3,     4,     1,     1,     1,     1,     1,     2,     2,     1,
     1,     0,     2,     1,     1,     2,     2,     2,     2,     1,
     1,     1,     2,     1,     2,     1,     2,     1,     2,     1,
     2,     3,     3,     3,     3,     3,     3,     3,     1,     2,
     3,     3,     3,     1,     1
};

static const short yydefact[] = {     0,
    45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    23,     0,    30,    32,    38,     0,
     0,    25,     0,     0,   162,     0,   148,   153,     0,     0,
   154,   155,     0,     0,     0,     0,   160,   161,     9,    13,
    10,     0,    15,    17,     0,     0,     0,     0,    24,   156,
   157,     0,     0,     0,     0,    31,    33,    37,   194,   195,
    34,    35,    36,    39,    42,    26,    11,    21,    20,    43,
     0,     0,   149,     0,     0,     0,    29,     0,     0,     0,
    12,     0,    14,    16,    22,     0,     0,   159,   158,     0,
    27,    40,    41,   164,   165,   171,   170,     0,   172,   174,
   176,   178,   180,     0,   189,     0,     0,     0,     0,     0,
   163,     8,     0,   151,   150,     0,   147,   115,   110,   111,
     0,   113,     0,     0,     0,     0,     0,     0,   133,     2,
    46,     3,     4,     1,    19,    18,    28,     0,     0,     0,
     0,     0,   168,   169,   173,   175,   177,   179,   181,   190,
   166,   167,     6,     0,   152,     0,    47,   117,   108,   109,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   114,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    88,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   118,   119,
     0,   121,     0,     0,     0,     0,     0,     0,   116,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   182,   183,   184,   185,   186,   187,   188,
   191,   192,   193,     7,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   107,     0,   139,
   138,     0,     0,   135,   136,     0,   137,     0,   127,   128,
   144,   129,   130,   131,   132,     5,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    46,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   140,   142,   143,   141,   112,    48,    49,
    50,    51,    52,    57,    58,    59,    60,     0,    62,    63,
    64,    65,    66,     0,    68,    69,     0,    71,    72,    73,
    74,    75,     0,    53,     0,    55,    76,     0,     0,     0,
     0,     0,    82,    83,    84,    85,    86,    87,    93,     0,
     0,     0,     0,    95,    96,    97,    91,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   120,     0,     0,     0,
     0,     0,   134,     0,     0,     0,   145,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    61,    67,    70,    54,     0,    56,    77,     0,
     0,     0,     0,     0,     0,    94,     0,    92,   103,   104,
   105,    99,     0,     0,    98,   102,     0,     0,   124,     0,
   126,   146,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    78,    79,    80,    81,    89,    90,
   106,   100,   101,   122,   123,   125,     0,     0,     0
};

static const short yydefgoto[] = {   557,
   129,   477,   478,    31,   131,    33,    55,    39,    70,   111,
    63
};

static const short yypact[] = {   418,
-32768,    21,    26,    26,    26,    26,    22,    22,    22,    26,
    22,    22,    26,    35,    26,   101,    26,    26,    95,    22,
    26,    26,    22,    63,-32768,     7,-32768,-32768,    17,    60,
-32768,   -78,    68,   -48,   -44,   -38,-32768,-32768,-32768,    26,
-32768,   -36,    26,    26,    26,   -78,   -19,   -17,-32768,-32768,
-32768,    48,    48,    48,    48,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    26,-32768,-32768,-32768,-32768,-32768,   168,
   109,    94,-32768,   111,    23,    27,-32768,    86,    86,    86,
-32768,    86,-32768,-32768,-32768,   128,   112,-32768,-32768,    48,
-32768,-32768,   -78,-32768,-32768,-32768,-32768,     1,-32768,-32768,
-32768,-32768,-32768,     2,-32768,     4,     5,     8,   224,   -47,
-32768,   135,   138,-32768,-32768,   139,-32768,-32768,    -2,-32768,
    86,-32768,    86,    86,    86,   587,    86,    86,-32768,   360,
-32768,   360,   360,   360,-32768,-32768,-32768,   146,    39,   152,
   153,   154,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   155,-32768,   156,-32768,-32768,-32768,-32768,
    25,    29,    30,    33,    37,    42,    45,    49,    51,    56,
    57,    59,    62,    64,    70,    71,    72,    82,-32768,    84,
    89,    92,    96,   103,   104,   105,   107,   108,   115,   116,
   118,   119,   131,   132,   133,   137,   141,   142,   145,-32768,
   147,   148,   149,   150,   151,   160,   161,   162,   163,   164,
   165,   166,   173,   174,   175,   180,   216,   269,-32768,-32768,
   270,-32768,   271,   272,   273,   274,   277,  1028,-32768,    86,
    86,    86,    19,    86,    61,    32,    86,    86,    86,    86,
    86,    86,    86,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   187,    36,    26,    26,    26,    26,    26,
    86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
    86,    86,    86,    86,    86,    86,    86,    86,    86,    76,
    76,    86,    86,    86,    86,    86,    86,    86,    86,    86,
    86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
    86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
    86,    86,    26,    26,    26,    26,    26,-32768,  1798,  1823,
   212,    86,    86,  1834,  1834,    86,  1834,    86,   -63,   -63,
   -63,    28,    28,    28,-32768,-32768,   202,   100,   279,   280,
   282,   308,  1044,  1060,  1076,  1092,   343,  1108,  1124,  1140,
  1156,  1172,   443,  1188,  1204,   460,  1220,  1236,  1252,  1268,
  1284,   557,   -90,   309,   586,   310,  1300,   603,   620,   637,
   654,   671,  1316,  1332,  1348,  1364,  1380,  1396,  1412,   688,
   705,   722,   739,  1428,  1444,  1460,  1476,   756,   773,   790,
   807,   824,   841,   858,   875,   892,  1492,   136,   144,   311,
   312,   313,    86,  1834,  1834,  1834,  1834,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    86,-32768,-32768,
-32768,-32768,-32768,    86,-32768,-32768,    86,-32768,-32768,-32768,
-32768,-32768,    86,-32768,    86,-32768,-32768,    86,    86,    86,
    86,    86,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    86,
    86,    86,    86,-32768,-32768,-32768,-32768,    86,    86,    86,
    86,    26,    26,    26,    26,    26,-32768,    26,    26,    26,
    26,    26,  1811,  1508,  1524,  1540,   360,   -25,   -21,  1556,
   909,   926,   943,   960,   977,   994,  1572,  1011,  1588,  1604,
  1620,  1636,   320,   326,   340,   342,   364,   369,   370,   372,
   373,   375,-32768,-32768,-32768,-32768,    86,-32768,-32768,    86,
    86,    86,    86,    86,    86,-32768,    86,-32768,-32768,-32768,
-32768,-32768,    86,    86,-32768,-32768,    26,    26,-32768,    26,
-32768,   360,  1652,  1668,  1684,  1700,  1716,  1732,  1748,  1764,
  1780,   376,   377,   378,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   217,   252,-32768
};

static const short yypgoto[] = {-32768,
   117,    99,  -219,    74,    -3,    41,    73,   178,-32768,-32768,
-32768
};


#define	YYLAST		1975


static const short yytable[] = {    32,
    32,    32,    32,    38,    38,    38,    32,    38,    38,    46,
    71,    32,    32,    32,    32,    32,    38,    32,    32,    38,
    73,   118,   119,   120,    37,    28,   115,    29,    28,    26,
    29,    27,    28,    28,    29,    29,    46,    76,    47,    46,
    46,    32,   245,    48,    34,    35,    36,   151,   152,    76,
    42,    50,    51,  -155,   121,    49,    54,    56,    57,    61,
    93,    65,    66,   118,   119,   120,    68,    28,    75,    29,
    77,    69,   117,   122,   240,   241,   242,   243,   118,   119,
   120,    27,    28,    78,    29,    85,    45,    79,   118,   119,
   120,    62,    28,    80,    29,    82,   121,    58,    50,    51,
    27,    28,   113,    29,    50,    51,    27,    28,    86,    29,
    87,   121,   112,    81,   114,   122,    83,    84,   506,   507,
   136,   121,   508,   507,    88,    89,    90,    91,    59,    60,
   122,   135,   138,   139,    72,   140,   141,    92,   153,   142,
   122,   154,   155,   156,   246,   247,   248,   249,   250,   244,
   322,   323,   123,   124,   125,   251,   252,   253,   254,   255,
   126,   127,   137,   328,    74,   128,    30,   256,   243,    30,
   116,   257,   258,    30,    30,   259,   130,   132,   133,   260,
   134,   337,    52,    53,   261,    40,    41,   262,    43,    44,
   336,   263,   326,   264,   123,   124,   125,    64,   265,   266,
    67,   267,   126,   127,   268,   408,   269,   128,    30,   123,
   124,   125,   270,   271,   272,   479,   558,   126,   127,   123,
   124,   125,   128,    30,   273,   228,   274,   126,   127,    52,
    53,   275,   128,    30,   276,    52,    53,   157,   277,   158,
   159,   160,    30,   409,   229,   278,   279,   280,    30,   281,
   282,   559,    32,    32,    32,    32,    32,   283,   284,     0,
   285,   286,    94,    95,    96,    97,    98,    99,   100,   101,
   102,   103,   104,   287,   288,   289,   363,   363,   105,   290,
   468,     0,   106,   291,   292,   107,   108,   293,   469,   294,
   295,   296,   297,   298,     0,     0,   338,   339,   340,   341,
   342,   109,   299,   300,   301,   302,   303,   304,   305,    32,
    32,    32,    32,    32,   110,   306,   307,   308,   143,   144,
   364,   366,   309,   145,   146,   147,   148,   149,   319,   320,
   321,   324,   325,   327,   150,   329,   330,   331,   332,   333,
   334,   335,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,   398,   399,   400,   401,   402,   310,   343,
   344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
   354,   355,   356,   357,   358,   359,   360,   361,   362,   365,
   367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
   377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
   387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
   397,   311,   312,   313,   314,   315,   316,   -44,     1,   317,
   404,   405,   410,   411,   406,   412,   407,     2,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,   413,   434,   436,     0,   470,   471,   472,    32,    32,
    32,    32,    32,   522,    32,    32,    32,    32,    32,   230,
   523,   231,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,   524,   525,   230,   418,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,   473,   493,   494,   495,   496,   497,   526,   498,   499,
   500,   501,   502,   527,   528,   529,   474,   530,   531,   554,
   555,   556,   475,    32,    32,   476,    32,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   480,   481,   482,   483,
   484,     0,     0,     0,     0,     0,     0,     0,   485,   486,
   487,   488,     0,     0,     0,     0,   489,   490,   491,   492,
     0,     0,     0,     0,     0,     0,     0,   542,   543,   230,
   544,   231,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,     0,     0,   230,   424,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,     0,     0,   427,   532,     0,     0,   533,   534,
   535,   536,   537,   538,     0,   539,     0,     0,     0,     0,
     0,   540,   541,   161,   162,   163,   164,   165,   166,   167,
   168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
   198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
   208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
   218,     0,     0,   230,     0,   231,   232,   233,   234,   235,
   236,   237,   238,   239,   240,   241,   242,   243,   219,   220,
   221,   433,     0,     0,     0,     0,   222,   223,   224,   225,
   226,   227,   230,     0,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,     0,   230,
   435,   231,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,     0,     0,   230,   438,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,     0,   230,   439,   231,   232,   233,   234,   235,
   236,   237,   238,   239,   240,   241,   242,   243,     0,     0,
   230,   440,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,     0,   230,   441,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,     0,     0,   230,   442,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     0,   230,   450,   231,   232,   233,   234,   235,   236,   237,
   238,   239,   240,   241,   242,   243,     0,     0,   230,   451,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,     0,   230,   452,   231,   232,   233,
   234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     0,     0,   230,   453,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,     0,   230,
   458,   231,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,     0,     0,   230,   459,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,     0,   230,   460,   231,   232,   233,   234,   235,
   236,   237,   238,   239,   240,   241,   242,   243,     0,     0,
   230,   461,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,     0,   230,   462,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,     0,     0,   230,   463,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     0,   230,   464,   231,   232,   233,   234,   235,   236,   237,
   238,   239,   240,   241,   242,   243,     0,     0,   230,   465,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,     0,   230,   466,   231,   232,   233,
   234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     0,     0,   230,   510,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,     0,   230,
   511,   231,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,     0,     0,   230,   512,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,     0,   230,   513,   231,   232,   233,   234,   235,
   236,   237,   238,   239,   240,   241,   242,   243,     0,     0,
   230,   514,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,     0,   230,   515,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,     0,     0,   230,   517,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   318,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   414,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   415,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   416,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   417,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   419,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   420,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   421,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   422,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   423,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   425,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   426,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   428,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   429,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   430,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   431,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   432,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   437,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   443,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   444,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   445,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   446,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   447,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   448,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   449,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   454,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   455,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   456,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   457,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   467,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   503,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   504,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   505,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   509,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   516,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   518,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   519,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   520,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   521,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   545,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   546,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   547,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,   230,   548,   231,   232,   233,   234,   235,   236,
   237,   238,   239,   240,   241,   242,   243,     0,   230,   549,
   231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
   241,   242,   243,     0,   230,   550,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
   230,   551,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,     0,   230,   552,   231,   232,
   233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
   243,     0,     0,   553,   230,   403,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   242,   243,   231,
   232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,   232,   233,   234,   235,   236,   237,   238,   239,
   240,   241,   242,   243,-32768,-32768,-32768,-32768,   237,   238,
   239,   240,   241,   242,   243
};

static const short yycheck[] = {     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
     4,    15,    16,    17,    18,    19,    20,    21,    22,    23,
     4,     3,     4,     5,     3,     7,     4,     9,     7,     9,
     9,     6,     7,     7,     9,     9,    40,   128,     4,    43,
    44,    45,     4,     9,     4,     5,     6,    95,    96,   128,
    10,     4,     5,   144,    36,    15,    16,    17,    18,    19,
    64,    21,    22,     3,     4,     5,     4,     7,     9,     9,
     3,     9,    76,    55,   138,   139,   140,   141,     3,     4,
     5,     6,     7,   132,     9,    45,    13,   132,     3,     4,
     5,    19,     7,   132,     9,   132,    36,     3,     4,     5,
     6,     7,     9,     9,     4,     5,     6,     7,   128,     9,
   128,    36,     4,    40,     4,    55,    43,    44,   144,   145,
     9,    36,   144,   145,    52,    53,    54,    55,    34,    35,
    55,     4,   132,   132,   128,   132,   132,    64,     4,   132,
    55,     4,     4,   146,   106,   107,   108,   109,   110,     4,
   132,   133,   134,   135,   136,     4,     4,     4,     4,     4,
   142,   143,    90,   132,   148,   147,   148,   143,   141,   148,
   148,   143,   143,   148,   148,   143,    78,    79,    80,   143,
    82,   146,   135,   136,   143,     8,     9,   143,    11,    12,
     4,   143,   132,   143,   134,   135,   136,    20,   143,   143,
    23,   143,   142,   143,   143,     4,   143,   147,   148,   134,
   135,   136,   143,   143,   143,   435,     0,   142,   143,   134,
   135,   136,   147,   148,   143,   127,   143,   142,   143,   135,
   136,   143,   147,   148,   143,   135,   136,   121,   143,   123,
   124,   125,   148,   144,   128,   143,   143,   143,   148,   143,
   143,     0,   256,   257,   258,   259,   260,   143,   143,    -1,
   143,   143,    95,    96,    97,    98,    99,   100,   101,   102,
   103,   104,   105,   143,   143,   143,   280,   281,   111,   143,
   145,    -1,   115,   143,   143,   118,   119,   143,   145,   143,
   143,   143,   143,   143,    -1,    -1,   256,   257,   258,   259,
   260,   134,   143,   143,   143,   143,   143,   143,   143,   313,
   314,   315,   316,   317,   147,   143,   143,   143,    95,    96,
   280,   281,   143,   100,   101,   102,   103,   104,   230,   231,
   232,   233,   234,   235,   111,   237,   238,   239,   240,   241,
   242,   243,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,   313,   314,   315,   316,   317,   143,   261,
   262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
   282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
   292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
   312,   143,   143,   143,   143,   143,   143,     0,     1,   143,
   322,   323,   144,   144,   326,   144,   328,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,   144,   144,   144,    -1,   145,   145,   145,   462,   463,
   464,   465,   466,   144,   468,   469,   470,   471,   472,   127,
   145,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,   145,   144,   127,   145,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,   403,   462,   463,   464,   465,   466,   144,   468,   469,
   470,   471,   472,   145,   145,   144,   418,   145,   144,   144,
   144,   144,   424,   527,   528,   427,   530,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   438,   439,   440,   441,
   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,   451,
   452,   453,    -1,    -1,    -1,    -1,   458,   459,   460,   461,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,   528,   127,
   530,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,    -1,    -1,   127,   145,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,    -1,    -1,   145,   507,    -1,    -1,   510,   511,
   512,   513,   514,   515,    -1,   517,    -1,    -1,    -1,    -1,
    -1,   523,   524,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    -1,    -1,   127,    -1,   129,   130,   131,   132,   133,
   134,   135,   136,   137,   138,   139,   140,   141,   112,   113,
   114,   145,    -1,    -1,    -1,    -1,   120,   121,   122,   123,
   124,   125,   127,    -1,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,    -1,   127,
   145,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,    -1,    -1,   127,   145,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,    -1,   127,   145,   129,   130,   131,   132,   133,
   134,   135,   136,   137,   138,   139,   140,   141,    -1,    -1,
   127,   145,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,    -1,   127,   145,   129,
   130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
   140,   141,    -1,    -1,   127,   145,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
    -1,   127,   145,   129,   130,   131,   132,   133,   134,   135,
   136,   137,   138,   139,   140,   141,    -1,    -1,   127,   145,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,    -1,   127,   145,   129,   130,   131,
   132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
    -1,    -1,   127,   145,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,    -1,   127,
   145,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,    -1,    -1,   127,   145,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,    -1,   127,   145,   129,   130,   131,   132,   133,
   134,   135,   136,   137,   138,   139,   140,   141,    -1,    -1,
   127,   145,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,    -1,   127,   145,   129,
   130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
   140,   141,    -1,    -1,   127,   145,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
    -1,   127,   145,   129,   130,   131,   132,   133,   134,   135,
   136,   137,   138,   139,   140,   141,    -1,    -1,   127,   145,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,    -1,   127,   145,   129,   130,   131,
   132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
    -1,    -1,   127,   145,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,    -1,   127,
   145,   129,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,    -1,    -1,   127,   145,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,    -1,   127,   145,   129,   130,   131,   132,   133,
   134,   135,   136,   137,   138,   139,   140,   141,    -1,    -1,
   127,   145,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,    -1,   127,   145,   129,
   130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
   140,   141,    -1,    -1,   127,   145,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,   127,   144,   129,   130,   131,   132,   133,   134,
   135,   136,   137,   138,   139,   140,   141,    -1,   127,   144,
   129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
   139,   140,   141,    -1,   127,   144,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
   127,   144,   129,   130,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141,    -1,   127,   144,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,    -1,    -1,   144,   127,   128,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,   129,
   130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
   140,   141,   130,   131,   132,   133,   134,   135,   136,   137,
   138,   139,   140,   141,   131,   132,   133,   134,   135,   136,
   137,   138,   139,   140,   141
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug=1;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 169 "bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 194 "gram.y"
{ let(yyvsp[-2].rval.left.vp, yyvsp[0].enode); ;
    break;}
case 2:
#line 196 "gram.y"
{ slet(yyvsp[-2].rval.left.vp, yyvsp[0].enode, 0); ;
    break;}
case 3:
#line 198 "gram.y"
{ slet(yyvsp[-2].rval.left.vp, yyvsp[0].enode, -1); ;
    break;}
case 4:
#line 200 "gram.y"
{ slet(yyvsp[-2].rval.left.vp, yyvsp[0].enode, 1); ;
    break;}
case 5:
#line 202 "gram.y"
{ doformat(yyvsp[-5].ival,yyvsp[-3].ival,yyvsp[-2].ival,yyvsp[-1].ival,yyvsp[0].ival); ;
    break;}
case 6:
#line 204 "gram.y"
{ doformat(yyvsp[-3].ival,yyvsp[-3].ival,yyvsp[-2].ival,yyvsp[-1].ival,yyvsp[0].ival); ;
    break;}
case 7:
#line 206 "gram.y"
{ doformat(yyvsp[-4].ival,yyvsp[-2].ival,yyvsp[-1].ival,yyvsp[0].ival, REFMTFIX); ;
    break;}
case 8:
#line 208 "gram.y"
{ doformat(yyvsp[-2].ival,yyvsp[-2].ival,yyvsp[-1].ival,yyvsp[0].ival, REFMTFIX); ;
    break;}
case 9:
#line 209 "gram.y"
{  /* This tmp hack is because readfile
				    * recurses back through yyparse. */
				  char *tmp;
				  tmp = yyvsp[0].sval;
				  readfile (tmp, 1);
				  scxfree(tmp);
				;
    break;}
case 10:
#line 216 "gram.y"
{
				  char *tmp;
				  tmp = yyvsp[0].sval;
				  readfile (tmp, 0);
				  scxfree(tmp);
				;
    break;}
case 11:
#line 223 "gram.y"
{ if (mdir) scxfree(mdir); mdir = yyvsp[0].sval; ;
    break;}
case 12:
#line 225 "gram.y"
{ (void) writefile(yyvsp[-1].sval, (yyvsp[0].rval.left.vp)->row, 
			 	(yyvsp[0].rval.left.vp)->col, (yyvsp[0].rval.right.vp)->row,
			 	(yyvsp[0].rval.right.vp)->col);
			 	scxfree(yyvsp[-1].sval); ;
    break;}
case 13:
#line 230 "gram.y"
{ (void) writefile (yyvsp[0].sval, 0, 0, maxrow, maxcol);
			 	scxfree(yyvsp[0].sval); ;
    break;}
case 14:
#line 232 "gram.y"
{ (void) printfile(yyvsp[-1].sval, (yyvsp[0].rval.left.vp)->row, 
			 (yyvsp[0].rval.left.vp)->col, (yyvsp[0].rval.right.vp)->row,
			 (yyvsp[0].rval.right.vp)->col);
			 scxfree(yyvsp[-1].sval); ;
    break;}
case 15:
#line 236 "gram.y"
{ (void) printfile (yyvsp[0].sval, 0, 0, maxrow, maxcol);
			 scxfree(yyvsp[0].sval); ;
    break;}
case 16:
#line 238 "gram.y"
{ (void) tblprintfile(yyvsp[-1].sval, (yyvsp[0].rval.left.vp)->row, 
			 (yyvsp[0].rval.left.vp)->col, (yyvsp[0].rval.right.vp)->row,
			 (yyvsp[0].rval.right.vp)->col);
			 scxfree(yyvsp[-1].sval); ;
    break;}
case 17:
#line 242 "gram.y"
{ (void)tblprintfile (yyvsp[0].sval, 0, 0, maxrow, maxcol);
			 scxfree(yyvsp[0].sval); ;
    break;}
case 18:
#line 245 "gram.y"
{ showcol( yyvsp[-2].ival, yyvsp[0].ival); ;
    break;}
case 19:
#line 247 "gram.y"
{ showrow( yyvsp[-2].ival, yyvsp[0].ival); ;
    break;}
case 20:
#line 249 "gram.y"
{ hide_col( yyvsp[0].ival ); ;
    break;}
case 21:
#line 251 "gram.y"
{ hide_row( yyvsp[0].ival ); ;
    break;}
case 22:
#line 253 "gram.y"
{ copy(yyvsp[-1].rval.left.vp,yyvsp[-1].rval.right.vp,
					yyvsp[0].rval.left.vp,yyvsp[0].rval.right.vp); ;
    break;}
case 23:
#line 256 "gram.y"
{ eraser(lookat(showsr, showsc),
				        lookat(currow, curcol)); ;
    break;}
case 24:
#line 259 "gram.y"
{ eraser(yyvsp[0].rval.left.vp, yyvsp[0].rval.right.vp); ;
    break;}
case 25:
#line 260 "gram.y"
{ valueize_area(showsr, showsc, currow, curcol);
				 modflg++; ;
    break;}
case 26:
#line 262 "gram.y"
{ valueize_area((yyvsp[0].rval.left.vp)->row,
					(yyvsp[0].rval.left.vp)->col,
					(yyvsp[0].rval.right.vp)->row,
					(yyvsp[0].rval.right.vp)->col); modflg++; ;
    break;}
case 27:
#line 266 "gram.y"
{ fill(lookat(showsr, showsc),
				      lookat(currow, curcol), yyvsp[-1].fval, yyvsp[0].fval); ;
    break;}
case 28:
#line 269 "gram.y"
{ fill(yyvsp[-2].rval.left.vp, yyvsp[-2].rval.right.vp, yyvsp[-1].fval, yyvsp[0].fval); ;
    break;}
case 29:
#line 271 "gram.y"
{ format_cell(yyvsp[-1].rval.left.vp, yyvsp[-1].rval.right.vp, yyvsp[0].sval); ;
    break;}
case 30:
#line 273 "gram.y"
{ lock_cells(lookat(showsr, showsc),
				        lookat(currow, curcol)); ;
    break;}
case 31:
#line 276 "gram.y"
{ lock_cells(yyvsp[0].rval.left.vp, yyvsp[0].rval.right.vp); ;
    break;}
case 32:
#line 278 "gram.y"
{ unlock_cells(lookat(showsr, showsc),
				        lookat(currow, curcol)); ;
    break;}
case 33:
#line 281 "gram.y"
{ unlock_cells(yyvsp[0].rval.left.vp, yyvsp[0].rval.right.vp); ;
    break;}
case 34:
#line 282 "gram.y"
{moveto(yyvsp[0].rval.left.vp->row, yyvsp[0].rval.left.vp->col);;
    break;}
case 35:
#line 283 "gram.y"
{ num_search(yyvsp[0].fval, 0); ;
    break;}
case 37:
#line 285 "gram.y"
{ str_search(yyvsp[0].sval); ;
    break;}
case 38:
#line 286 "gram.y"
{ go_last(); ;
    break;}
case 39:
#line 287 "gram.y"
{ struct ent_ptr arg1, arg2;
					arg1.vp = lookat(showsr, showsc);
					arg1.vf = 0;
					arg2.vp = lookat(currow, curcol);
					arg2.vf = 0;
                                        if (arg1.vp == arg2.vp)
                                           add_range(yyvsp[0].sval, arg2, arg2, 0);
                                        else
                                           add_range(yyvsp[0].sval, arg1, arg2, 1); ;
    break;}
case 40:
#line 297 "gram.y"
{ add_range(yyvsp[-1].sval, yyvsp[0].rval.left, yyvsp[0].rval.right, 1); ;
    break;}
case 41:
#line 298 "gram.y"
{ add_range(yyvsp[-1].sval, yyvsp[0].ent, yyvsp[0].ent, 0); ;
    break;}
case 42:
#line 299 "gram.y"
{ del_range(yyvsp[0].rval.left.vp, yyvsp[0].rval.right.vp); ;
    break;}
case 46:
#line 305 "gram.y"
{ yyval.enode = new_var(O_VAR, yyvsp[0].ent); ;
    break;}
case 47:
#line 306 "gram.y"
{ yyval.enode = new ('f', ENULL, yyvsp[0].enode); ;
    break;}
case 48:
#line 308 "gram.y"
{ yyval.enode = new_range(REDUCE | '+', yyvsp[-1].rval); ;
    break;}
case 49:
#line 310 "gram.y"
{ yyval.enode = new_range (REDUCE | '*', yyvsp[-1].rval); ;
    break;}
case 50:
#line 312 "gram.y"
{ yyval.enode = new_range (REDUCE | 'a', yyvsp[-1].rval); ;
    break;}
case 51:
#line 314 "gram.y"
{ yyval.enode = new_range (REDUCE | 's', yyvsp[-1].rval); ;
    break;}
case 52:
#line 316 "gram.y"
{ yyval.enode = new_range (REDUCE | 'c', yyvsp[-1].rval); ;
    break;}
case 53:
#line 318 "gram.y"
{ yyval.enode = new_range (REDUCE | MAXR, yyvsp[-1].rval); ;
    break;}
case 54:
#line 320 "gram.y"
{ yyval.enode = new(LMAX, yyvsp[-1].enode, yyvsp[-3].enode); ;
    break;}
case 55:
#line 322 "gram.y"
{ yyval.enode = new_range (REDUCE | MINR, yyvsp[-1].rval); ;
    break;}
case 56:
#line 324 "gram.y"
{ yyval.enode = new(LMIN, yyvsp[-1].enode, yyvsp[-3].enode); ;
    break;}
case 57:
#line 325 "gram.y"
{ yyval.enode = new(ABS, ENULL, yyvsp[-1].enode); ;
    break;}
case 58:
#line 326 "gram.y"
{ yyval.enode = new(ACOS, ENULL, yyvsp[-1].enode); ;
    break;}
case 59:
#line 327 "gram.y"
{ yyval.enode = new(ASIN, ENULL, yyvsp[-1].enode); ;
    break;}
case 60:
#line 328 "gram.y"
{ yyval.enode = new(ATAN, ENULL, yyvsp[-1].enode); ;
    break;}
case 61:
#line 329 "gram.y"
{ yyval.enode = new(ATAN2, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 62:
#line 330 "gram.y"
{ yyval.enode = new(CEIL, ENULL, yyvsp[-1].enode); ;
    break;}
case 63:
#line 331 "gram.y"
{ yyval.enode = new(COS, ENULL, yyvsp[-1].enode); ;
    break;}
case 64:
#line 332 "gram.y"
{ yyval.enode = new(EXP, ENULL, yyvsp[-1].enode); ;
    break;}
case 65:
#line 333 "gram.y"
{ yyval.enode = new(FABS, ENULL, yyvsp[-1].enode); ;
    break;}
case 66:
#line 334 "gram.y"
{ yyval.enode = new(FLOOR, ENULL, yyvsp[-1].enode); ;
    break;}
case 67:
#line 335 "gram.y"
{ yyval.enode = new(HYPOT, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 68:
#line 336 "gram.y"
{ yyval.enode = new(LOG, ENULL, yyvsp[-1].enode); ;
    break;}
case 69:
#line 337 "gram.y"
{ yyval.enode = new(LOG10, ENULL, yyvsp[-1].enode); ;
    break;}
case 70:
#line 338 "gram.y"
{ yyval.enode = new(POW, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 71:
#line 339 "gram.y"
{ yyval.enode = new(SIN, ENULL, yyvsp[-1].enode); ;
    break;}
case 72:
#line 340 "gram.y"
{ yyval.enode = new(SQRT, ENULL, yyvsp[-1].enode); ;
    break;}
case 73:
#line 341 "gram.y"
{ yyval.enode = new(TAN, ENULL, yyvsp[-1].enode); ;
    break;}
case 74:
#line 342 "gram.y"
{ yyval.enode = new(DTR, ENULL, yyvsp[-1].enode); ;
    break;}
case 75:
#line 343 "gram.y"
{ yyval.enode = new(RTD, ENULL, yyvsp[-1].enode); ;
    break;}
case 76:
#line 344 "gram.y"
{ yyval.enode = new(RND, ENULL, yyvsp[-1].enode); ;
    break;}
case 77:
#line 345 "gram.y"
{ yyval.enode = new(ROUND, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 78:
#line 346 "gram.y"
{ yyval.enode = new(IF,  yyvsp[-5].enode,new(',',yyvsp[-3].enode,yyvsp[-1].enode)); ;
    break;}
case 79:
#line 348 "gram.y"
{ yyval.enode = new(PV,  yyvsp[-5].enode,new(':',yyvsp[-3].enode,yyvsp[-1].enode)); ;
    break;}
case 80:
#line 349 "gram.y"
{ yyval.enode = new(FV,  yyvsp[-5].enode,new(':',yyvsp[-3].enode,yyvsp[-1].enode)); ;
    break;}
case 81:
#line 350 "gram.y"
{ yyval.enode = new(PMT, yyvsp[-5].enode,new(':',yyvsp[-3].enode,yyvsp[-1].enode)); ;
    break;}
case 82:
#line 352 "gram.y"
{ yyval.enode = new(HOUR,ENULL, yyvsp[-1].enode); ;
    break;}
case 83:
#line 353 "gram.y"
{ yyval.enode = new(MINUTE,ENULL, yyvsp[-1].enode); ;
    break;}
case 84:
#line 354 "gram.y"
{ yyval.enode = new(SECOND,ENULL, yyvsp[-1].enode); ;
    break;}
case 85:
#line 355 "gram.y"
{ yyval.enode = new(MONTH,ENULL,yyvsp[-1].enode); ;
    break;}
case 86:
#line 356 "gram.y"
{ yyval.enode = new(DAY, ENULL, yyvsp[-1].enode); ;
    break;}
case 87:
#line 357 "gram.y"
{ yyval.enode = new(YEAR, ENULL, yyvsp[-1].enode); ;
    break;}
case 88:
#line 358 "gram.y"
{ yyval.enode = new(NOW, ENULL, ENULL);;
    break;}
case 89:
#line 360 "gram.y"
{ yyval.enode = new(DTS, yyvsp[-5].enode, new(',', yyvsp[-3].enode, yyvsp[-1].enode));;
    break;}
case 90:
#line 362 "gram.y"
{ yyval.enode = new(TTS, yyvsp[-5].enode, new(',', yyvsp[-3].enode, yyvsp[-1].enode));;
    break;}
case 91:
#line 363 "gram.y"
{ yyval.enode = new(STON, ENULL, yyvsp[-1].enode); ;
    break;}
case 92:
#line 364 "gram.y"
{ yyval.enode = new (EQS, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 93:
#line 365 "gram.y"
{ yyval.enode = new(DATE, ENULL, yyvsp[-1].enode); ;
    break;}
case 94:
#line 366 "gram.y"
{ yyval.enode = new(FMT, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 95:
#line 367 "gram.y"
{ yyval.enode = new(UPPER, ENULL, yyvsp[-1].enode); ;
    break;}
case 96:
#line 368 "gram.y"
{ yyval.enode = new(LOWER, ENULL, yyvsp[-1].enode); ;
    break;}
case 97:
#line 369 "gram.y"
{ yyval.enode = new(CAPITAL, ENULL, yyvsp[-1].enode); ;
    break;}
case 98:
#line 371 "gram.y"
{ yyval.enode = new(INDEX, yyvsp[-3].enode, new_range(REDUCE | INDEX, yyvsp[-1].rval)); ;
    break;}
case 99:
#line 373 "gram.y"
{ yyval.enode = new(LOOKUP, yyvsp[-3].enode, new_range(REDUCE | LOOKUP, yyvsp[-1].rval)); ;
    break;}
case 100:
#line 375 "gram.y"
{ yyval.enode = new(HLOOKUP, new(',', yyvsp[-5].enode, yyvsp[-1].enode),
		    new_range((REDUCE | HLOOKUP), yyvsp[-3].rval)); ;
    break;}
case 101:
#line 378 "gram.y"
{ yyval.enode = new(VLOOKUP, new(',', yyvsp[-5].enode, yyvsp[-1].enode),
		    new_range((REDUCE | VLOOKUP), yyvsp[-3].rval)); ;
    break;}
case 102:
#line 381 "gram.y"
{ yyval.enode = new(STINDEX, yyvsp[-3].enode, new_range((REDUCE | STINDEX), yyvsp[-1].rval)); ;
    break;}
case 103:
#line 382 "gram.y"
{ yyval.enode = new(EXT, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 104:
#line 383 "gram.y"
{ yyval.enode = new(NVAL, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 105:
#line 384 "gram.y"
{ yyval.enode = new(SVAL, yyvsp[-3].enode, yyvsp[-1].enode); ;
    break;}
case 106:
#line 386 "gram.y"
{ yyval.enode = new(SUBSTR, yyvsp[-5].enode, new(',', yyvsp[-3].enode, yyvsp[-1].enode)); ;
    break;}
case 107:
#line 387 "gram.y"
{ yyval.enode = yyvsp[-1].enode; ;
    break;}
case 108:
#line 388 "gram.y"
{ yyval.enode = yyvsp[0].enode; ;
    break;}
case 109:
#line 389 "gram.y"
{ yyval.enode = new ('m', ENULL, yyvsp[0].enode); ;
    break;}
case 110:
#line 390 "gram.y"
{ yyval.enode = new_const(O_CONST, (double) yyvsp[0].ival); ;
    break;}
case 111:
#line 391 "gram.y"
{ yyval.enode = new_const(O_CONST, yyvsp[0].fval); ;
    break;}
case 112:
#line 393 "gram.y"
{
			int y = yyvsp[0].ival;

			/* Convert 'NN' to years since 1970.
			 * (or 2000, fix by 2070)
			 */
			if (y < 100) {		/* Full year not given */
				if (y >= 70)	/* 70-99 == Years since 1900 */
					y += 1900;
				else		/* 00-69 == Years since 2000 */
					y += 2000;
			}
			yyval.enode = new_const(O_CONST, dodts(yyvsp[-4].ival, yyvsp[-2].ival, y));
		;
    break;}
case 113:
#line 407 "gram.y"
{ yyval.enode = new_const(O_CONST, PI); ;
    break;}
case 114:
#line 408 "gram.y"
{ yyval.enode = new_const(O_CONST, PI); ;
    break;}
case 115:
#line 409 "gram.y"
{ yyval.enode = new_str(yyvsp[0].sval); ;
    break;}
case 116:
#line 410 "gram.y"
{ yyval.enode = new ('~', ENULL, yyvsp[0].enode); ;
    break;}
case 117:
#line 411 "gram.y"
{ yyval.enode = new ('~', ENULL, yyvsp[0].enode); ;
    break;}
case 118:
#line 412 "gram.y"
{ yyval.enode = new(MYROW, ENULL, ENULL);;
    break;}
case 119:
#line 413 "gram.y"
{ yyval.enode = new(MYCOL, ENULL, ENULL);;
    break;}
case 120:
#line 414 "gram.y"
{ yyval.enode = new(COLTOA, ENULL, yyvsp[-1].enode);;
    break;}
case 121:
#line 415 "gram.y"
{ yyval.enode = new(NUMITER, ENULL, ENULL);;
    break;}
case 122:
#line 420 "gram.y"
{;
    break;}
case 123:
#line 423 "gram.y"
{;
    break;}
case 124:
#line 426 "gram.y"
{;
    break;}
case 125:
#line 429 "gram.y"
{;
    break;}
case 126:
#line 432 "gram.y"
{;
    break;}
case 127:
#line 436 "gram.y"
{ yyval.enode = new ('+', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 128:
#line 437 "gram.y"
{ yyval.enode = new ('-', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 129:
#line 438 "gram.y"
{ yyval.enode = new ('*', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 130:
#line 439 "gram.y"
{ yyval.enode = new ('/', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 131:
#line 440 "gram.y"
{ yyval.enode = new ('%', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 132:
#line 441 "gram.y"
{ yyval.enode = new ('^', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 134:
#line 443 "gram.y"
{ yyval.enode = new ('?', yyvsp[-4].enode, new(':', yyvsp[-2].enode, yyvsp[0].enode)); ;
    break;}
case 135:
#line 444 "gram.y"
{ yyval.enode = new ('<', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 136:
#line 445 "gram.y"
{ yyval.enode = new ('=', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 137:
#line 446 "gram.y"
{ yyval.enode = new ('>', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 138:
#line 447 "gram.y"
{ yyval.enode = new ('&', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 139:
#line 448 "gram.y"
{ yyval.enode = new ('|', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 140:
#line 449 "gram.y"
{ yyval.enode = new ('~', ENULL, new ('>', yyvsp[-3].enode, yyvsp[0].enode)); ;
    break;}
case 141:
#line 450 "gram.y"
{ yyval.enode = new ('~', ENULL, new ('=', yyvsp[-3].enode, yyvsp[0].enode)); ;
    break;}
case 142:
#line 451 "gram.y"
{ yyval.enode = new ('~', ENULL, new ('=', yyvsp[-3].enode, yyvsp[0].enode)); ;
    break;}
case 143:
#line 452 "gram.y"
{ yyval.enode = new ('~', ENULL, new ('<', yyvsp[-3].enode, yyvsp[0].enode)); ;
    break;}
case 144:
#line 453 "gram.y"
{ yyval.enode = new ('#', yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 145:
#line 457 "gram.y"
{ yyval.enode = new(ELIST, ENULL, yyvsp[0].enode); ;
    break;}
case 146:
#line 458 "gram.y"
{ yyval.enode = new(ELIST, yyvsp[-2].enode, yyvsp[0].enode); ;
    break;}
case 147:
#line 461 "gram.y"
{ yyval.rval.left = yyvsp[-2].ent; yyval.rval.right = yyvsp[0].ent; ;
    break;}
case 148:
#line 462 "gram.y"
{ yyval.rval = yyvsp[0].rval; ;
    break;}
case 149:
#line 465 "gram.y"
{ yyval.ent.vp = lookat(yyvsp[0].ival , yyvsp[-1].ival); yyval.ent.vf = 0; ;
    break;}
case 150:
#line 466 "gram.y"
{ yyval.ent.vp = lookat(yyvsp[0].ival , yyvsp[-1].ival);
					yyval.ent.vf = FIX_COL; ;
    break;}
case 151:
#line 468 "gram.y"
{ yyval.ent.vp = lookat(yyvsp[0].ival , yyvsp[-2].ival);
					yyval.ent.vf = FIX_ROW; ;
    break;}
case 152:
#line 470 "gram.y"
{ yyval.ent.vp = lookat(yyvsp[0].ival , yyvsp[-2].ival);
					yyval.ent.vf = FIX_ROW | FIX_COL; ;
    break;}
case 153:
#line 472 "gram.y"
{ yyval.ent = yyvsp[0].rval.left; ;
    break;}
case 154:
#line 475 "gram.y"
{ yyval.rval = yyvsp[0].rval; ;
    break;}
case 155:
#line 476 "gram.y"
{ yyval.rval.left = yyvsp[0].ent; yyval.rval.right = yyvsp[0].ent; ;
    break;}
case 156:
#line 480 "gram.y"
{ yyval.fval = (double) yyvsp[0].ival; ;
    break;}
case 157:
#line 481 "gram.y"
{ yyval.fval = yyvsp[0].fval; ;
    break;}
case 158:
#line 482 "gram.y"
{ yyval.fval = -yyvsp[0].fval; ;
    break;}
case 159:
#line 483 "gram.y"
{ yyval.fval = yyvsp[0].fval; ;
    break;}
case 160:
#line 487 "gram.y"
{ yyval.sval = yyvsp[0].sval; ;
    break;}
case 161:
#line 488 "gram.y"
{
				    char *s, *s1;
				    s1 = yyvsp[0].ent.vp->label;
				    if (!s1)
					s1 = "NULL_STRING";
				    s = scxmalloc((unsigned)(strlen(s1)+1));
				    (void) strcpy(s, s1);
				    yyval.sval = s;
				;
    break;}
case 164:
#line 505 "gram.y"
{ setauto(1); ;
    break;}
case 165:
#line 506 "gram.y"
{ setauto(1); ;
    break;}
case 166:
#line 507 "gram.y"
{ setauto(0); ;
    break;}
case 167:
#line 508 "gram.y"
{ setauto(0); ;
    break;}
case 168:
#line 509 "gram.y"
{ setauto(0); ;
    break;}
case 169:
#line 510 "gram.y"
{ setauto(0); ;
    break;}
case 170:
#line 511 "gram.y"
{ setorder(BYCOLS); ;
    break;}
case 171:
#line 512 "gram.y"
{ setorder(BYROWS); ;
    break;}
case 172:
#line 513 "gram.y"
{ numeric = 1; ;
    break;}
case 173:
#line 514 "gram.y"
{ numeric = 0; ;
    break;}
case 174:
#line 515 "gram.y"
{ prescale = 0.01; ;
    break;}
case 175:
#line 516 "gram.y"
{ prescale = 1.0; ;
    break;}
case 176:
#line 517 "gram.y"
{ extfunc = 1; ;
    break;}
case 177:
#line 518 "gram.y"
{ extfunc = 0; ;
    break;}
case 178:
#line 519 "gram.y"
{ showcell = 1; ;
    break;}
case 179:
#line 520 "gram.y"
{ showcell = 0; ;
    break;}
case 180:
#line 521 "gram.y"
{ showtop = 1; ;
    break;}
case 181:
#line 522 "gram.y"
{ showtop = 0; ;
    break;}
case 182:
#line 523 "gram.y"
{ setiterations(yyvsp[0].ival); ;
    break;}
case 183:
#line 524 "gram.y"
{ tbl_style = yyvsp[0].ival; ;
    break;}
case 184:
#line 525 "gram.y"
{ tbl_style = TBL; ;
    break;}
case 185:
#line 526 "gram.y"
{ tbl_style = LATEX; ;
    break;}
case 186:
#line 527 "gram.y"
{ tbl_style = SLATEX; ;
    break;}
case 187:
#line 528 "gram.y"
{ tbl_style = TEX; ;
    break;}
case 188:
#line 529 "gram.y"
{ tbl_style = FRAME; ;
    break;}
case 189:
#line 530 "gram.y"
{ rndinfinity = 1; FullUpdate++; ;
    break;}
case 190:
#line 531 "gram.y"
{ rndinfinity = 0; FullUpdate++; ;
    break;}
case 191:
#line 532 "gram.y"
{ craction = yyvsp[0].ival; ;
    break;}
case 192:
#line 533 "gram.y"
{ rowlimit = yyvsp[0].ival; ;
    break;}
case 193:
#line 534 "gram.y"
{ collimit = yyvsp[0].ival; ;
    break;}
case 194:
#line 538 "gram.y"
{ num_search((double)0, CELLERROR); ;
    break;}
case 195:
#line 539 "gram.y"
{ num_search((double)0, CELLINVALID); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 442 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 541 "gram.y"
